//
// եѴκŬ
//

#include <iostream>
#include <cmath>

using namespace std;

#include        "Mat.h"
#include        "Tensor.h"
#include        "Cast.h"

#include        "affine.h"

// 襤饤ؿ
static inline double
sqr(double x)
{
   return x * x;
}

// ˥塼ȥˡνͤη׻
int
init_affine(VecC* x0, VecC* x1, int N, Mat& A)
{
   VecC         xC0, xC1;
   VecC         xt0, xt1;
   Mat          M0(2,2), M1(2,2), a(2,2);

   // ſη׻
   xC0.clear(0.0);
   xC1.clear(0.0);
   for (int i = 0; i < N; i++)
   {
      xC0 += x0[i];
      xC1 += x1[i];
   }
   xC0 /= (double)N;
   xC1 /= (double)N;

   // ſѰ̤Υ⡼ȹ
   M0.clear(0.0);
   M1.clear(0.0);
   for (int i = 0; i < N; i++)
   {
      xt0 = x0[i] - xC0;
      xt1 = x1[i] - xC1;
      M0[0][0] += sqr(xt0[0]);
      M0[1][1] += sqr(xt0[1]);
      M0[0][1] += xt0[0] * xt0[1];

      M1[0][0] += xt0[0] * xt1[0];
      M1[1][1] += xt0[1] * xt1[1];
      M1[0][1] += xt0[1] * xt1[0];
      M1[1][0] += xt0[0] * xt1[1];
   }
   M0[1][0] = M0[0][1];

   a = M1 * inverse(M0);

   A[0][0] = a[0][0];
   A[0][1] = a[0][1];
   A[0][2] = xC1[0] - (a[0][0] * xC0[0] + a[0][1] * xC0[1]);
   A[1][0] = a[1][0];
   A[1][1] = a[1][1];
   A[1][2] = xC1[1] - (a[1][0] * xC0[0] + a[1][1] * xC0[1]);
   A[2][0] = A[2][1] = 0.0;
   A[2][2] = 1.0;

   return 0;
}

// Ť߹צη׻
static Mat
calc_Wa(Mat& A)
{
   Mat  T, Wa;
   Mat	Pk(1.0, 0.0, 0.0,
	   0.0, 1.0, 0.0,
	   0.0, 0.0, 0.0);

   T = A * Pk * (~A) + Pk;
   Wa = trc_gen_inv(T, 2);

   return Wa;
}

// ۹Aʤη׻
static Mat
grad_DaJ(VecC* x0, VecC* x1, int N, Mat Wa, Mat& A)
{
   Mat          DaJ;
   VecC         Ea;

   DaJ.clear(0.0);
   for (int i = 0; i < N; i++)
   {
      Ea = x1[i] -  A * x0[i];
      DaJ += Wa * Ea * (~x0[i]);
   }
   DaJ *=  -2.0 / (double)N;

   return DaJ;
}

// إåƥ󥽥η׻
static Tensor4
hesse_tensor_H(VecC *x0, int N, Mat& Wa)
{
   Tensor4      H;

   H.clear(0.0);

   for (int i = 0; i < 3; i++)
      for (int j = 0; j < 3; j++)
         for (int k = 0; k < 3; k++)
            for (int l = 0; l < 3; l++)
               for (int a = 0; a < N; a++)
                  H(i,j,k,l) += Wa[i][k] * x0[a][j] * x0[a][l];

   H *= 2.0 / (double)N;

   return H;
}

// 99κ66ʬȴФ
static Mat
submatrix66(Mat& H)
{
   Mat  T(6,6);

   if (H.row() != 9 || H.col() != 9)
   {
      cerr << "submatrix: wrong matrix size!" << endl;
      exit(1);
   }

   for (int i = 0; i < 6; i++)
      for (int j = 0; j < 6; j++)
         T[i][j] = H[i][j];

   return T;
}

// 9٥ȥ6ʬȴФ
static VecC
subvector6(VecC& V)
{
   VecC T(6);

   if (V.size() != 9)
   {
      cerr << "subvector: wrong vector size!" << endl;
      exit(1);
   }

   for (int i = 0; i < 6; i++)
      T[i] = V[i];

   return T;
}

// 6٥ȥ뤫 9٥ȥ
static VecC
envector9(VecC& V)
{
   VecC T(9);

   if (V.size() != 6)
   {
      cerr << "envector: wrong vector size!" << endl;
      exit(1);
   }

   for (int i = 0; i < 6; i++)
      T[i] = V[i];

   T[6] = T[7] = T[8] = 0.0;

   return T;
}

//
// եѴ׻ (˥塼ȥˡ)
//
double
calc_affine(VecC* x0, VecC* x1, int N, Mat& Ah,
	    double eps_A, int max_itr, double *eh, int *count)
{
   double       J;
   double       dAn;
   Mat          A, dA;
   Mat		Wa;
   Tensor4      H;
   Mat          DaJ;
   Mat          Hmat(9,9), Hmat2(6,6);
   VecC         DaJvec(9), dAvec(9), DaJvec2(6), dAvec2(6);
   Mat          EgMat[9];
   VecC         EgVal(9);
   int          iter;
   VecC         Ea, xAx;

   // ͤη׻
   init_affine(x0, x1, N, A);

   Wa = calc_Wa(A);
   J = 0.0;
   for (int i = 0; i < N; i++)
   {
      xAx = x1[i] -  A * x0[i];
      J += (xAx , (Wa * xAx));
   }
   J /= (double)N;

   iter = 0;
   do
   {
      iter++;

      if (iter > max_itr)
      {
         cerr << "affine fitting: iteration over! " << endl;
         *count = max_itr;
         return ERR_J;
      }

      // ۹aʤη׻
      DaJ = grad_DaJ(x0, x1, N, Wa, A);

      // إåƥ󥽥Ȥη׻
      H = hesse_tensor_H(x0, N, Wa);

      // 999٥ȥؤѴ
      DaJvec = Type9(DaJ);
      Hmat = Type99(H);

      // 66ʬȴ
      Hmat2 = submatrix66(Hmat);
      DaJvec2 = subvector6(DaJvec);

      // ̵չˤϢΩ켡β
      dAvec = - gen_inv(Hmat) * DaJvec;
      dA = Type33(dAvec);

      A += dA;
      dAn = dA.norm();

      // צκƷ׻
      Wa = calc_Wa(A);

      J = 0.0;
      for (int i = 0; i < N; i++)
      {
         xAx = x1[i] -  A * x0[i];
         J += (xAx , (Wa * xAx));
      }
      J /= (double)N;
   }
   while (fabs(dAn) >= eps_A);

   J = 0.0;
   for (int i = 0; i < N; i++)
   {
      xAx = x1[i] -  A * x0[i];
      J += (xAx , (Wa * xAx));
   }
   J /= (double)N;

   *eh = J / (2.0 - 6.0 / N);
   *count = iter;

   Ah = A;

   return J;
}

//
// եѴ׻ (Levenberg-Marquardtˡ)
//
double
calc_affinelm(VecC* x0, VecC* x1, int N, Mat& Ah,
	      double eps_A, int max_itr, double *eh, int *count)
{
   double       J;
   double       dAn;
   Mat          A, dA;
   Tensor4      H;
   Mat          DaJ;
   Mat          Wa;
   Mat          Hmat(9,9), Hmat2(6,6);
   VecC         DaJvec(9), dAvec(9), DaJvec2(6), dAvec2(6);
   Mat          EgMat[9];
   VecC         EgVal(9);
   int          iter;
   VecC         Ea, xAx;
   // LM ˡΤѿ
   Mat		Hmat21(6,6), DD(6,6);
   Mat		AA;
   double	lambda, J1, J2, dJ;
   int		lm_flag;

   // ͤη׻
   init_affine(x0, x1, N, A);

   Wa = calc_Wa(A);
   J = 0.0;
   for (int i = 0; i < N; i++)
   {
      xAx = x1[i] -  A * x0[i];
      J += (xAx , (Wa * xAx));
   }
   J /= (double)N;
   
   // for LM
   J1 = J;
   lambda = Init_Lambda;

   iter = 0;
   do
   {
      iter++;
      lm_flag = 0;

      if (iter > max_itr)
      {
         cerr << "affine fitting: iteration over! " << endl;
         *count = max_itr;
         return ERR_J;
      }

      // ۹aʤη׻
      DaJ = grad_DaJ(x0, x1, N, Wa, A);

      // إåƥ󥽥Ȥη׻
      H = hesse_tensor_H(x0, N, Wa);

      // 999٥ȥؤѴ
      DaJvec = Type9(DaJ);
      Hmat = Type99(H);

      // 66ʬȴ
      Hmat2 = submatrix66(Hmat);
      DD = diag(Hmat2);
      DaJvec2 = subvector6(DaJvec);

      // LM LOOP
      do
      {
	 if (lm_flag)
	    lambda *= Mult_Lambda;
	 else
	    lm_flag++;

	 Hmat21 = Hmat2 + lambda * DD;
	 
	 // ϢΩ켡β
	 dAvec2 = SLE(Hmat21, -DaJvec2);
	 dA = Type33(envector9(dAvec2));

	 AA = A + dA;

	 // צη׻
	 Wa = calc_Wa(AA);

	 J2 = 0.0;
	 for (int i = 0; i < N; i++)
	 {
	    xAx = x1[i] -  AA * x0[i];
	    J2 += (xAx , (Wa * xAx));
	 }
	 J2 /= (double)N;
      }
      while (J2 > J1);

      dJ = J1 - J2;
      J1 = J2;
      A = AA;
      lambda /= Mult_Lambda;

      dAn = dA.norm();
   }
   while (fabs(dAn) >= eps_A);

   J = 0.0;
   for (int i = 0; i < N; i++)
   {
      xAx = x1[i] -  A * x0[i];
      J += (xAx , (Wa * xAx));
   }
   J /= (double)N;

   *eh = J / (2.0 - 6.0 / N);
   *count = iter;

   Ah = A;

   return J;
}
