//
//	ּͱѴμư׻(1)
//	2001ǯ821

#include	<iostream>
#include	<cstdio>

using namespace std;

#include	"CImage.h"
#include	"Mat.h"
#include	"Corresp_cls.h"

#define	LMEDS_MAIN
#include	"automatch.h"
#include	"lmeds.h"
#include	"homography.h"
#include	"grouping.h"
#include	"init_match.h"
#include	"rematch.h"

// form ؿ
#define TMPBUFLEN       80
static char tmpbuff[TMPBUFLEN];

// μ
static void
set_seed(long *idum)
{
   long	t;

   t = (long)time(NULL);
   *idum = ((t >> 16) << 16) - t;
   if (*idum > 0)
      *idum = -(*idum);
}


// ħν
void
print_features(Point pt[], int N, char *mes)
{
   // إå
   cerr << "<" << mes << ">" << endl;

   // ǡ
   for (int i = 0; i < N; i++)
   {
      snprintf(tmpbuff, TMPBUFLEN, "(%4d,%4d)", pt[i].u, pt[i].v);
      cerr << tmpbuff << endl;
   }

   // եå
   cerr << "</" << mes << ">" << endl;
}

// бν
void
print_matches(Corresp *cp, int N, char *mes)
{
   // إå
   cerr << "<" << mes << ">" << endl;

   // ǡ
   for (int i = 0; i < N; i++)
   {
      snprintf(tmpbuff, TMPBUFLEN, "(%4d,%4d)--(%4d,%4d)",
               cp[i].ua, cp[i].va, cp[i].ub, cp[i].vb);
      cout << tmpbuff << endl;
   }
   // եå
   cerr << "</" << mes << ">" << endl;
}

// бΥԡ
void
copy_corresp(Corresp **csrc, Corresp **cdst, int N)
{
   // Ƴ
   if (*cdst)  delete [] *cdst;
   *cdst = new Corresp [N];

   // ԡ
   for (int i = 0; i < N; i++)
   {
      (*cdst)[i].ua = (*csrc)[i].ua;
      (*cdst)[i].va = (*csrc)[i].va;
      (*cdst)[i].ub = (*csrc)[i].ub;
      (*cdst)[i].vb = (*csrc)[i].vb;
   }

   // ˴
   delete [] *csrc;
}

// ɸѴ
static void
trans_pairs(int width, int height, double fl,
	    Corresp cp[], int N,
	    VecC Xa[], VecC Xb[])
{
   int	w2, h2;

   w2 = width / 2;
   h2 = height / 2;
   for (int i = 0; i < N; i++)
   {
      Xa[i][0] = (double)(h2 - cp[i].va) / fl;
      Xa[i][1] = (double)(cp[i].ua - w2) / fl;
      Xa[i][2] = 1.0;

      Xb[i][0] = (double)(h2 - cp[i].vb) / fl;
      Xb[i][1] = (double)(cp[i].ub - w2) / fl;
      Xb[i][2] = 1.0;
   }
}


// γݤۤ
void
alloc_and_set_vec(Corresp cp[], int N, int width, int height, double fl,
		  double **J, VecC **Xa, VecC **Xb)
{
   // J_{\lambda}, Xa, Xb γ
   if (*J) delete [] *J;	// ⤷ݤƤ顥
   if (*Xa) delete [] *Xa;
   if (*Xb) delete [] *Xb;

   *J = new double [N];
   *Xa = new VecC [N];
   *Xb = new VecC [N];

   // ɸϤѴ
   trans_pairs(width, height, fl, cp, N, *Xa, *Xb);
}

// ɸѴ
static void
trans_pairs(int width, int height, Corresp cp[], int N,
	    Complex za[], Complex zb[])
{
   int	w2, h2;

   w2 = width / 2;
   h2 = height / 2;
   for (int i = 0; i < N; i++)
   {
      za[i] = Complex((double)(h2 - cp[i].va), (double)(cp[i].ua - w2));
      zb[i] = Complex((double)(h2 - cp[i].vb), (double)(cp[i].ub - w2));
   }
}

// γݤۤ
void
alloc_and_set_complex(Corresp crt1[], int N1, int width, int height,
		      double **J, Complex **za, Complex **zb)
{
   // J_{\lambda}, za, zb(ʣǿ)γ
   if (*J) delete [] *J;	// ⤷ݤƤ顥
   if (*za) delete [] *za;
   if (*zb) delete [] *zb;

   *J = new double [N1];
   *za = new Complex [N1];
   *zb = new Complex [N1];

   // ɸϤѴ
   trans_pairs(width, height, crt1, N1, *za, *zb);
}

// ͱѴμư׻(ʬۥǥ)
void
automatch_homography(CImage& CIm1, CImage& CIm2, double fl,
		     int Np, int tp_size,
		     double pc, double pc_step, double dthd,
                     int ImpHrsFlg,
		     Corresp **cp, int *NN,
		     Point **pa, int *Na, Point **pb, int *Nb,
		     Mat& H, int verbose)
{
   Mat		Jab;
   Corresp	*crt1, *crt2, *crt3;	// б
   int		N1, N2, N3;		// бФθĿ
   VecC		*Xa, *Xb;		// ħ(٥ȥ)
   Complex	*za, *zb;		// ħ(ʣǿ)
   double	*J;			// бФλĺ

   int		width, height;
   double	Sm;

   int		tp_step = 4;		// ƥץ졼Ȥγ祹ƥå

   // ¿
   VecC		Tm, Tr;
   // Ѵ
   double	ssm, ssr;
   Complex	Zm, zzm0, zzm1;
   VecC		tm(2), tr(2);
   Mat		Rm(2,2), Rr(2,2);
   // եѴ
   Mat		Am, Ar;
   Mat		Wm, Wr;
   // ͱѴ
   Mat		Hm, Hr, Ht;

   // ꤳˡ
   double	eh;
   int		cnt;

   // 쥤Ѵ
   Image	Im1(CIm1.width(), CIm1.height());
   Image	Im2(CIm2.width(), CIm2.height());

   CImagetoImage(CIm1, Im1);
   CImagetoImage(CIm2, Im2);

   width = Im1.width();
   height = Im1.height();
   Image_set_quiet();	// ΰ賰ץåɽ
   crt1 = crt2 = crt3 = *cp = 0;

   // μ
   set_seed(&idum);

   // б
   (void)init_matching(Im1, Im2, Jab, pa, pb, Na, Nb, &crt1, &N1,
		       Np, tp_size, pc, ImpHrsFlg);

   if (verbose)
   {
      print_features(*pa, *Na, "image1");
      print_features(*pb, *Nb, "image2");
      print_matches(crt1, N1, "initial");
   }

   // γݤͤ
   J = 0;	// ǽϳݤƤʤ null
   Xa = Xb = 0;	// ǽϳݤƤʤ null
   alloc_and_set_vec(crt1, N1, width, height, fl, &J, &Xa, &Xb);

   // ƥå1
   // Ǿ᥸ˡˤ¿ʤη׻
   if (verbose) cerr << endl << "[[ first step: translation fitting ]]" << endl;
   Sm = lmeds_tr(crt1, Xa, Xb, J, N1, MAX_ITR, Tm);
   // ȥ饤(ƤϤ)
   if (verbose) cerr << "[[ recalc translation ]]" << endl;
   recalc_tr(crt1, Xa, Xb, J, N1, Sm, Tm, &crt2, &N2, Tr);
   if (verbose)
   {
      Ht.clear(0.0);
      Ht[0][0] = Ht[1][1] = Ht[2][2] = 1.0;
      Ht[0][2] = Tr[0];
      Ht[1][2] = Tr[1];
      Ht /= Ht.norm();
      cerr << "### Ht = " << Ht << endl;
      print_matches(crt2, N2, "tr1");
   }
   // б
   if (verbose) cerr << "[[ rematching translation ]]" << endl;
   pc += pc_step;
   if (pc > 1.0)  pc = 1.0;
   rematch_tr(Jab, *pa, *pb, width, height, fl,
	      Tr, Sm, pc, &crt3, &N3);
   if (verbose) print_matches(crt3, N3, "tr2");

   // ٳγݤͤ
   copy_corresp(&crt3, &crt1, N3);
   N1 = N3;
   za = zb = 0;	// null pointer set
   alloc_and_set_complex(crt1, N1, width, height, &J, &za, &zb);

   // ƥå2
   // Ǿ᥸ˡˤѴη׻
   if (verbose) cerr << endl << "[[ second step: similarity fitting ]]" << endl;
   Sm = lmeds_sim(crt1, za, zb, J, N1, MAX_ITR, Zm, &ssm, zzm0, zzm1);
   // ȥ饤(ƤϤ)
   if (verbose) cerr << "[[ recalc similarity ]]" << endl;
   recalc_sim(crt1, za, zb, J, N1, Sm, Zm, ssm, zzm0, zzm1,
	      &crt2, &N2, Rr, tr, &ssr);
   if (verbose)
   {
      Ht[0][0] = Rr[0][0]; Ht[0][1] = Rr[0][1]; Ht[0][2] = tr[0] / fl;
      Ht[1][0] = Rr[1][0]; Ht[1][1] = Rr[1][1]; Ht[1][2] = tr[1] / fl;
      Ht[2][0] = Ht[2][1] = 0.0; Ht[2][2] = 1.0;
      Ht /= Ht.norm();
      cerr << "### Hs = " << Ht << endl;
      print_matches(crt2, N2, "sim1");
   }
   // б
   if (verbose) cerr << "[[ rematching similarity ]]" << endl;
   tp_size += tp_step;	// ƥץ졼ȥ +4 
   pc += pc_step;
   if (pc > 1.0)  pc = 1.0;
   rematch_sim(Im1, Im2, Jab, *pa, *pb, width, height, fl,
		 ssr, Rr, tr, Sm, tp_size, pc, &crt3, &N3);
   if (verbose) print_matches(crt3, N3, "sim2");

   // ٳγݤͤ
   copy_corresp(&crt3, &crt1, N3);
   N1 = N3;
   alloc_and_set_vec(crt1, N1, width, height, fl, &J, &Xa, &Xb);

   // ƥå3
   if (verbose) cerr << endl << "[[ third step: affinity fitting ]]" << endl;
   // Ǿ᥸ˡˤ륢եѴη׻
   Sm = lmeds_aff(crt1, Xa, Xb, J, N1, MAX_ITR, Am, Wm);
   // ȥ饤(ƤϤ)
   recalc_aff(crt1, Xa, Xb, J, N1, Sm, Am, Wm,
	      &crt2, &N2, Ar, Wr);
   if (verbose)
   {
      Ht = Ar;
      Ht /= Ht.norm();
      cerr << "### Ha = " << Ht << endl;
      print_matches(crt2, N2, "aff1");
   }
   // б
   if (verbose) cerr << "[[ rematching afinity ]]" << endl;
   tp_size += tp_step;	// ƥץ졼ȥ +4 
   pc += pc_step;
   if (pc > 1.0)  pc = 1.0;
   rematch_aff(Im1, Im2, Jab, *pa, *pb, width, height, fl,
		 Ar, Wr, Sm, tp_size, pc, &crt3, &N3);
   if (verbose) print_matches(crt3, N3, "aff2");

   // ٳγݤͤ
   copy_corresp(&crt3, &crt1, N3);
   N1 = N3;
   alloc_and_set_vec(crt1, N1, width, height, fl, &J, &Xa, &Xb);

   // ƥå4
   if (verbose) cerr << endl << "[[ fourth step: homography fitting ]]" << endl;
   // Ǿ᥸ˡˤͱѴη׻
   Sm = lmeds_homo(crt1, Xa, Xb, J, N1, fl, MAX_ITR, Hm);
   // ȥ饤(ƤϤ)
   recalc_homo(crt1, Xa, Xb, J, N1, Sm, Hm, &crt2, &N2, Hr);
   if (verbose)
   {
      cerr << "### Hr = " << Hr << endl;
      print_matches(crt2, N2, "homo1");
   }
   // б
   if (verbose) cerr << "[[ rematching homography ]]" << endl;
   tp_size += tp_step;	// ƥץ졼ȥ +4 
   pc += pc_step;
   if (pc > 1.0)  pc = 1.0;
   rematch_homo(Im1, Im2, Jab, *pa, *pb, width, height, fl,
		Hr, dthd, tp_size, &crt3, &N3);
   if (verbose) print_matches(crt3, N3, "homo2");

   // ƥå5
   if (verbose) cerr << endl << "[[ fifth step: final homography fitting ]]" << endl;
   copy_corresp(&crt3, &crt1, N3);
   alloc_and_set_vec(crt1, N3, width, height, fl, &J, &Xa, &Xb);

   calc_homography(Xa, Xb, N3, H, 2, 1e-10, 30, &eh, &cnt);
   copy_corresp(&crt1, cp, N3);
   *NN = N3;
}
