//
// ͱѴκŬ
//

#include	<iostream>

#include	"Mat.h"
#include	"Tensor.h"
#include	"Cast.h"

#include	"homography.h"

using namespace std;

static const    VecC    e1(1.0, 0.0, 0.0);
static const    VecC    e2(0.0, 1.0, 0.0);
static const    VecC    e3(0.0, 0.0, 1.0);

static const	Mat	I3(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0);

// Υȥ졼
static double
trace(Mat& M)
{
   double	t = 0.0;
   int		N = (M.row() < M.col()? M.row(): M.col());
   
   for (int i = 0; i < N; i++)
      t += M[i][i];

   return t;
}
   
// 襤饤ؿ
static inline double
sqr(double x)
{
   return x * x;
}

// ͥåΥǥ륿
static inline int
KroneckerDelta(int i, int j)
{
   return ((i == j)? 1: 0);
}

// ǥ󥰥ȥΦ
int EddingtonEpsilon(int i, int j, int k)
{
  if (   (i==0 && j==1 && k==2)
      || (i==1 && j==2 && k==0)
      || (i==2 && j==0 && k==1))
     return 1;
  else if (   (i==0 && j==2 && k==1)
	   || (i==1 && j==0 && k==2)
	   || (i==2 && j==1 && k==0))
     return -1;
  else
     return 0;
}


// ꤳˡ
double
calc_homography(VecC* x0, VecC* x1, int N,
		Mat& Hh, int ord, double eps, int itmax,
		double *eh, int *cnt)
{
   int		count;
   double	c = 0.0, D, inp1, inp2, tmpd, J;
   Mat		V0a(1.0, 0.0, 0.0,
		    0.0, 1.0, 0.0,
		    0.0, 0.0, 0.0);
   Mat		V1a(1.0, 0.0, 0.0,
		    0.0, 1.0, 0.0,
		    0.0, 0.0, 0.0);
   Mat		Xa[3], H[9], tmpm, W;
   VecC		x0a, x1a;
   VecC		lambda(9);
   Tensor4	tM, tN1, tN2, Mhat;

   tM.clear(0.0);
   tN1.clear(0.0);
   tN2.clear(0.0);
   for (int a = 0; a < N; a++)
   {
      x0a = x0[a];
      x1a = x1[a];
      
	 // Calculate tensor M.
      Xa[0] = e1 % (x1a * (~x0a));
      Xa[1] = e2 % (x1a * (~x0a));
      Xa[2] = e3 % (x1a * (~x0a));
      tM += TensorProduct(Xa[0], Xa[0]);
      tM += TensorProduct(Xa[1], Xa[1]);
      tM += TensorProduct(Xa[2], Xa[2]);

	 // Calculate parts of tensor N1 and N2.
      for (int i = 0; i < 3; i++)
	 for (int j = 0; j < 3; j++)
	    for (int k = 0; k < 3; k++)
	       for (int l = 0; l < 3; l++)
		  if ((3*(i-1)+j) <= (3*(k-1)+l))
		  {
		     tN1(i,j,k,l) += KroneckerDelta(i, k)
			* (V0a[j][l] * sqr(x1a.norm())
			   + trace(V1a) * x0a[j] * x0a[l])
			- (V0a[j][l] * x1a[i] * x1a[k]
			   + V1a[i][k] * x0a[j] * x0a[l]);
		     if (ord == 2)
		     {
			tN2(i,j,k,l) += KroneckerDelta(i, k)
			   * V0a[j][l] * trace(V1a)
			   - V0a[j][l] * V1a[i][k];
		     }
		  }
   }

      // Copy the rest of tensor N1 and N2.
   for (int i = 0; i < 3; i++)
      for (int j = 0; j < 3; j++)
	 for (int k = 0; k < 3; k++)
	    for (int l = 0; l < 3; l++)
	       if ((3*(i-1)+j) > (3*(k-1)+l))
	       {
		  tN1(i,j,k,l) = tN1(k,l,i,j);
		  if (ord == 2)
		     tN2(i,j,k,l) = tN2(k,l,i,j);
	       }

   Mhat = tM / N;
   tN1 = tN1 / N;
   if (ord == 2)
      tN2 = tN2/N;

      // Calculate eigensystem of M-hat.
   Eigen3333(Mhat, lambda, H);

   if (lambda[8] < 0.0) lambda[8] = -lambda[8];

      // Renormalization loop.
   count = 0;
   do
   {
      count++;

	 // Renew c.
      inp1 = (H[8] , (tN1 * H[8]));
      if (ord == 2)
      {
	 inp2 = (H[8] , (tN2 * H[8]));
	 tmpd = inp1 - 2.0 * c * inp2;
	 D = sqr(tmpd) - 4.0 * lambda[8] * inp2;
	 if (D >= 0)
	    c += ((tmpd-sqrt(D)) / (2.0 * inp2));
	 else
	    c += lambda[8] / inp1;
      }
      else
	 c += lambda[8] / inp1;

	 // Initialize tensor M, N1 and N2. 
      for (int i = 0; i < 3; i++)
	 for (int j = 0; j < 3; j++)
	    for (int k = 0; k < 3; k++)
	       for (int l = 0; l < 3; l++)
	       {
		  tM(i,j,k,l) = 0.0;
		  tN1(i,j,k,l) = 0.0;
		  if (ord == 2) tN2(i,j,k,l) = 0.0;
	       }

      for (int a = 0; a < N; a++)
      {
      
	    // Take out data from x0 and x1.
	 x0a = x0[a];
	 x1a = x1[a];

	    // Renew weight matrix.
	 tmpm = H[8] * V0a * (~H[8]);
	 W = x1a % tmpm % x1a + (H[8] * x0a) % V1a % (H[8] * x0a);
	 if (ord == 2) W += c * ext_product(tmpm, V1a);
	 W = trc_gen_inv(W, 2);

	    // Calculate tensor M.
	 Xa[0] = e1 % (x1a * (~x0a));
	 Xa[1] = e2 % (x1a * (~x0a));
	 Xa[2] = e3 % (x1a * (~x0a));
	 for (int k = 0; k < 3; k++)
	    for (int l = 0; l < 3; l++)
	       tM += W[k][l] * TensorProduct(Xa[k], Xa[l]);
      
	    // Calculate parts of tensor N1 and N2.
	 for (int i = 0; i < 3; i++)
	    for (int j = 0; j < 3; j++)
	       for (int k = 0; k < 3; k++)
		  for (int l = 0; l < 3; l++)
		     if ((3*(i-1)+j) <= (3*(k-1)+l))
			for (int m = 0; m < 3; m++)
			   for (int n = 0; n < 3; n++)
			      for (int p = 0; p < 3; p++)
				 for (int q = 0; q < 3; q++)
				 {
				    tN1(i,j,k,l) +=
				       + EddingtonEpsilon(i, m, p)
				       * EddingtonEpsilon(k, n, q)
				       * W[m][n]
				       * (V0a[j][l] * x1a[p] * x1a[q]
					  + V1a[p][q] * x0a[j] * x0a[l]);
				    if (ord == 2)
				    {
				       tN2(i,j,k,l) +=
					  + EddingtonEpsilon(i, m, p)
					  * EddingtonEpsilon(k, n, q)
					  * W[m][n]
					  * V0a[j][l] * V1a[p][q];
				    }
				 }
      }
      
	 // Copy the rest of tensor N1 and N2.
      for (int i = 0; i < 3; i++)
	 for (int j = 0; j < 3; j++)
	    for (int k = 0; k < 3; k++)
	       for (int l = 0; l < 3; l++)    
		  if ((3*(i-1)+j) > (3*(k-1)+l))
		  {
		     tN1(i,j,k,l) = tN1(k,l,i,j);
		     if (ord == 2) tN2(i,j,k,l) = tN2(k,l,i,j);
		  }

      tM = tM / N;
      tN1 = tN1 / N;
      if (ord == 2)
      {
	 tN2 = tN2 / N;
	 Mhat = tM - c * tN1 + sqr(c) * tN2;
      }
      else
	 Mhat = tM - c * tN1;
   
	 // Calculate eigensystem of M-hat.
      Eigen3333(Mhat, lambda, H);
   }
   while ((fabs(lambda[8]) > eps) && (count < itmax));

      // Calculate output values.
   if (count < itmax)
   {
      Hh = H[8];
      if (det33(Hh) < 0.0) Hh = -Hh;
   }
   else
   {
      cerr << "homography fitting: maximum count exceeded!!" << endl;
      Hh = H[8];
      if (det33(Hh) < 0.0) Hh = -Hh;
      *cnt = itmax;
      return ERR_J;
   }

   J = 0.0;
   for (int a = 0; a < N; a++)
   {
      W = x1[a] % Hh * V0a * (~Hh) % x1[a]
	 + (Hh * x0[a]) % V1a % (Hh * x0[a]);
      W = trc_gen_inv(W, 2);
      J += ((x1[a] % (Hh * x0[a])) , W * (x1[a] % (Hh * x0[a])));
   }
   J /= (double)N;
   
   *cnt = count;
   *eh = J / (2.0 - 8.0 / (double)N);

   return J;
}

// ɸѰ̤
double
calc_homography(VecC* x0, VecC* x1, int N,
		Mat& Hh, Mat& Hp, Mat& Hm,
		int ord, double eps, int itmax,
		double *eh, int *cnt)
{
   int		count;
   double	c = 0.0, D, inp1, inp2, tmpd, J;
   Mat		V0a(1.0, 0.0, 0.0,
		    0.0, 1.0, 0.0,
		    0.0, 0.0, 0.0);
   Mat		V1a(1.0, 0.0, 0.0,
		    0.0, 1.0, 0.0,
		    0.0, 0.0, 0.0);
   Mat		Xa[3], H[9], tmpm, W, Delta;
   VecC		x0a, x1a;
   VecC		lambda(9);
   Tensor4	tM, tN1, tN2, Mhat;

   tM.clear(0.0);
   tN1.clear(0.0);
   tN2.clear(0.0);
   for (int a = 0; a < N; a++)
   {
      x0a = x0[a];
      x1a = x1[a];
      
	 // Calculate tensor M.
      Xa[0] = e1 % (x1a * (~x0a));
      Xa[1] = e2 % (x1a * (~x0a));
      Xa[2] = e3 % (x1a * (~x0a));
      tM += TensorProduct(Xa[0], Xa[0]);
      tM += TensorProduct(Xa[1], Xa[1]);
      tM += TensorProduct(Xa[2], Xa[2]);

	 // Calculate parts of tensor N1 and N2.
      for (int i = 0; i < 3; i++)
	 for (int j = 0; j < 3; j++)
	    for (int k = 0; k < 3; k++)
	       for (int l = 0; l < 3; l++)
		  if ((3*(i-1)+j) <= (3*(k-1)+l))
		  {
		     tN1(i,j,k,l) += KroneckerDelta(i, k)
			* (V0a[j][l] * sqr(x1a.norm())
			   + trace(V1a) * x0a[j] * x0a[l])
			- (V0a[j][l] * x1a[i] * x1a[k]
			   + V1a[i][k] * x0a[j] * x0a[l]);
		     if (ord == 2)
		     {
			tN2(i,j,k,l) += KroneckerDelta(i, k)
			   * V0a[j][l] * trace(V1a)
			   - V0a[j][l] * V1a[i][k];
		     }
		  }
   }

      // Copy the rest of tensor N1 and N2.
   for (int i = 0; i < 3; i++)
      for (int j = 0; j < 3; j++)
	 for (int k = 0; k < 3; k++)
	    for (int l = 0; l < 3; l++)
	       if ((3*(i-1)+j) > (3*(k-1)+l))
	       {
		  tN1(i,j,k,l) = tN1(k,l,i,j);
		  if (ord == 2)
		     tN2(i,j,k,l) = tN2(k,l,i,j);
	       }

   Mhat = tM / N;
   tN1 = tN1 / N;
   if (ord == 2)
      tN2 = tN2/N;

      // Calculate eigensystem of M-hat.
   Eigen3333(Mhat, lambda, H);

   if (lambda[8] < 0.0) lambda[8] = -lambda[8];

      // Renormalization loop.
   count = 0;
   do
   {
      count++;

	 // Renew c.
      inp1 = (H[8] , (tN1 * H[8]));
      if (ord == 2)
      {
	 inp2 = (H[8] , (tN2 * H[8]));
	 tmpd = inp1 - 2.0 * c * inp2;
	 D = sqr(tmpd) - 4.0 * lambda[8] * inp2;
	 if (D >= 0)
	    c += ((tmpd-sqrt(D)) / (2.0 * inp2));
	 else
	    c += lambda[8] / inp1;
      }
      else
	 c += lambda[8] / inp1;

	 // Initialize tensor M, N1 and N2. 
      for (int i = 0; i < 3; i++)
	 for (int j = 0; j < 3; j++)
	    for (int k = 0; k < 3; k++)
	       for (int l = 0; l < 3; l++)
	       {
		  tM(i,j,k,l) = 0.0;
		  tN1(i,j,k,l) = 0.0;
		  if (ord == 2) tN2(i,j,k,l) = 0.0;
	       }

      for (int a = 0; a < N; a++)
      {
      
	    // Take out data from x0 and x1.
	 x0a = x0[a];
	 x1a = x1[a];

	    // Renew weight matrix.
	 tmpm = H[8] * V0a * (~H[8]);
	 W = x1a % tmpm % x1a + (H[8] * x0a) % V1a % (H[8] * x0a);
	 if (ord == 2) W += c * ext_product(tmpm, V1a);
	 W = trc_gen_inv(W, 2);

	    // Calculate tensor M.
	 Xa[0] = e1 % (x1a * (~x0a));
	 Xa[1] = e2 % (x1a * (~x0a));
	 Xa[2] = e3 % (x1a * (~x0a));
	 for (int k = 0; k < 3; k++)
	    for (int l = 0; l < 3; l++)
	       tM += W[k][l] * TensorProduct(Xa[k], Xa[l]);
      
	    // Calculate parts of tensor N1 and N2.
	 for (int i = 0; i < 3; i++)
	    for (int j = 0; j < 3; j++)
	       for (int k = 0; k < 3; k++)
		  for (int l = 0; l < 3; l++)
		     if ((3*(i-1)+j) <= (3*(k-1)+l))
			for (int m = 0; m < 3; m++)
			   for (int n = 0; n < 3; n++)
			      for (int p = 0; p < 3; p++)
				 for (int q = 0; q < 3; q++)
				 {
				    tN1(i,j,k,l) +=
				       + EddingtonEpsilon(i, m, p)
				       * EddingtonEpsilon(k, n, q)
				       * W[m][n]
				       * (V0a[j][l] * x1a[p] * x1a[q]
					  + V1a[p][q] * x0a[j] * x0a[l]);
				    if (ord == 2)
				    {
				       tN2(i,j,k,l) +=
					  + EddingtonEpsilon(i, m, p)
					  * EddingtonEpsilon(k, n, q)
					  * W[m][n]
					  * V0a[j][l] * V1a[p][q];
				    }
				 }
      }
      
	 // Copy the rest of tensor N1 and N2.
      for (int i = 0; i < 3; i++)
	 for (int j = 0; j < 3; j++)
	    for (int k = 0; k < 3; k++)
	       for (int l = 0; l < 3; l++)    
		  if ((3*(i-1)+j) > (3*(k-1)+l))
		  {
		     tN1(i,j,k,l) = tN1(k,l,i,j);
		     if (ord == 2) tN2(i,j,k,l) = tN2(k,l,i,j);
		  }

      tM = tM / N;
      tN1 = tN1 / N;
      if (ord == 2)
      {
	 tN2 = tN2 / N;
	 Mhat = tM - c * tN1 + sqr(c) * tN2;
      }
      else
	 Mhat = tM - c * tN1;
   
	 // Calculate eigensystem of M-hat.
      Eigen3333(Mhat, lambda, H);

   }
   while ((fabs(lambda[8]) > eps) && (count < itmax));

      // Calculate output values.
   if (count < itmax)
   {
      Hh = H[8];
      if (det33(Hh) < 0.0) Hh = -Hh;
   }
   else
   {
      cerr << "homography fitting: maximum count exceeded!!" << endl;
      Hh = H[8];
      if (det33(Hh) < 0.0) Hh = -Hh;
      *cnt = itmax;
      return ERR_J;
   }

   J = 0.0;
   for (int a = 0; a < N; a++)
   {
      W = x1[a] % Hh * V0a * (~Hh) % x1[a]
	 + (Hh * x0[a]) % V1a % (Hh * x0[a]);
      W = trc_gen_inv(W, 2);
      J += ((x1[a] % (Hh * x0[a])) , W * (x1[a] % (Hh * x0[a])));
   }
   J /= (double)N;
   
   *cnt = count;
   
   *eh = J / (2.0 - 8.0 / (double)N);
   
   double	nl;
   nl = c / (1.0 - 4.0 / (double)N);

   Delta = sqrt(*eh / (lambda[7] * (double)N)) * H[7];
   Hp = normalize(Hh + Delta);
   Hm = normalize(Hh - Delta);
    
   return J;
}
