//
// б
//

#include <unistd.h>

#include "Mat.h"
#include "Image.h"
#include "CImage.h"
#include "Corresp_cls.h"
#include "grouping.h"
#include "Harris.h"
#include "init_match.h"

// 2
static double
sqr(double x)
{
   return x * x;
}

// ƥץ졼(1)2ħޤΰȤλĺʿ
static double
residual(IntTemplate& Ta, Image& Imb, Point& pb)
{
   double	s, d, b;
   int		sx, sy, ex, ey;

   sx = Ta.xmin();
   ex = Ta.xmax();
   sy = Ta.ymin();
   ey = Ta.ymax();
   
   s = 0.0;

   for (int y = sy; y <= ey; y++)
      for (int x = sx; x <= ex; x++)
      {
	 b = Imb.get_im_pixel2(pb.u + x, pb.v + y);
	 if (b < 0)	// ϰϳ
	    return MISMATCH;
	 d = Ta.get_im_pixel(x, y);
	 s += sqr(b - d);
      }
   return s;
}

// бɽκ
static void
make_table(IntTemplate *Ta, int Na,
	   Image& Imb, Point pb[], int Nb,
	   Mat& Jab)
{
   for (int a = 0; a < Na; a++)
      for (int b = 0; b < Nb; b++)
      {
	 Jab[a][b] = residual(Ta[a], Imb, pb[b]);
      }
}

// ̥ƥץ졼Ȥκ
static int
set_template(Image& Im, IntTemplate& T, Point& p)
{
   int		d;
   
   for (int j = T.ymin(); j <= T.ymax(); j++)
      for (int i = T.xmin(); i <= T.xmax(); i++)
      {
	 d = Im.get_im_pixel2(p.u+i, p.v+j);
	 if (d < 0)
	    return 0;
	 T.put_im_pixel(i, j, d);
      }
   return 1;
}

// ħޤΰ褫ƥץ졼Ȥ
static void
set_feature_templates(Image &Im, Point p[], int *Np,
		      IntTemplate **T, int Tsize)
{
   int		i, j;

   *T = new IntTemplate [*Np];

   // ƥץ졼ȤΥꥵ(ɬפʤ)
   if ((*T)[0].xl() != (2 * Tsize + 1))
   {
      for (i = 0; i < (*Np); i++)
	 (*T)[i].resize(Tsize, Tsize);
   }

   // ƥץ졼Ⱥ
   j = 0;
   for (i = 0; i < (*Np); i++, j++)
   {
      // ΰƤäƤƥץ졼ȤΤͭȤ
      while (!set_template(Im, (*T)[j], p[i]))
	 i++;
      p[j].u = p[i].u;
      p[j].v = p[i].v;
   }

   *Np = j;
}

// ħ
static void
feature_extraction(Image &Im, int Pmax, Point **p, int *N, int ImpHrsFlg)
{
   int		*u, *v;

   // Improved Harris
   if (ImpHrsFlg)
      ImpHarris(Im, &u, &v, N, H_Ns, H_sg, H_rk, H_s, Pmax, H_mindist);
   else
      Harris(Im, &u, &v, N, H_Ns, H_sg, H_rk, H_s, Pmax, H_mindist);

   *p = new Point [*N];

   // ħ֤Υԡ
   for (int i = 0; i < *N; i++)
   {
      (*p)[i].u = u[i];
      (*p)[i].v = v[i];
   }

   delete [] u;
   delete [] v;
}

// ɸФΥ
void
sort_index_pair(Mat &Jab, IndexPair idx[], int N)
{
   int		tmp;

   for (int i = 0; i < N - 1; i++)
   {
      if (Jab[idx[i].a][idx[i].b] == MISMATCH) continue;
      for (int j = i + 1; j < N; j++)
      {
	 if (Jab[idx[j].a][idx[j].b] == MISMATCH) continue;
	 if (Jab[idx[i].a][idx[i].b] > Jab[idx[j].a][idx[j].b])
	 {
	    tmp = idx[i].a;
	    idx[i].a = idx[j].a;
	    idx[j].a = tmp;
	    tmp = idx[i].b;
	    idx[i].b = idx[j].b;
	    idx[j].b = tmp;
	 }
      }
   }
}

// ǥκȥѥ
int
make_index(Mat &Jab, int Na, int Nb, IndexPair idx[], double x[])
{
   int	k;

   k = 0;
   for (int i = 0; i < Na; i++)
   {
      for (int j = 0; j < Nb; j++)
      {
	 if (Jab[i][j] >= 0.0)
	 {
	    idx[k].a = i;
	    idx[k].b = j;
	    x[k] = Jab[i][j];
	    k++;
	 }
      }
   }
   return k;
}

// бӽ
int
delete_mismatch(Mat &Jab, IndexPair idx[], int grp[], int N)
{
   int	c;

   c = 0;
   // grp[i] == 1 ǤϸбȤߤʤ
   for (int i = 0; i < N; i++)
   {
      if (grp[i] == 1)
      {
	 Jab[idx[i].a][idx[i].b] = MISMATCH;
	 c++;
      }
   }
   return c;
}


// бФι¤ΤؤѴ
void
corresp_pairs(Point pa[], Point pb[],
	      IndexPair idx[], int Nm, Corresp cp[])
{
   for (int i = 0; i < Nm; i++)
   {
      cp[i].ua = pa[idx[i].a].u;
      cp[i].va = pa[idx[i].a].v;
      cp[i].ub = pb[idx[i].b].u;
      cp[i].vb = pb[idx[i].b].v;
   }
}

// бγ
int
fix_corresp(Mat& Jab, int Na, int Nb, int N,
	    IndexPair idx0[], IndexPair idx[])
{
   int	k, Nm;

   Nm = k = 0;

   // ǽ餫бξν
   while (Jab[idx[k].a][idx[k].b] == MISMATCH)
      k++;

   // Ͽ
   idx0[Nm].a = idx[k].a;
   idx0[Nm++].b = idx[k].b;
   while (k < N)
   {
      // Ѥߤκ
      for (int j = 0; j < Nb; j++)
	 Jab[idx[k].a][j] = MISMATCH;

      for (int i = 0; i < Na; i++)
	 Jab[i][idx[k].b] = MISMATCH;

      // θ䥤ǥåڥ򸫤Ĥ
      while (++k < N && Jab[idx[k].a][idx[k].b] < 0.0);
      if (k >= N) goto END;

      idx0[Nm].a = idx[k].a;
      idx0[Nm++].b = idx[k].b;
   }

  END:

   return Nm;
}

// бγ
static int
make_corresp(Mat& Jab0,
	     Point pa[], int Na, Point pb[], int Nb,
	     double pc, IndexPair** idx0)
{
   Mat		Jab(Jab0);
   double	*x;
   int		N, Nm, Nu, L;
   IndexPair	*idx;

   int		*grp;
   int		thd;

   // γ
   N = Na * Nb;
   idx = new IndexPair [N];	// ǥ
   grp = new int [N];	// 롼
   x = new double [N];	// ѥ

   // ǥ
   N = make_index(Jab, Na, Nb, idx, x);

   // 롼ԥ
   L = (Na < Nb)? Na: Nb;
   thd = grouping(x, grp, L, N, pc, HISTMAX);

   // бκ
   Nu = delete_mismatch(Jab, idx, grp, N);

   // 
   sort_index_pair(Jab, idx, N);

   // ŤʤäƤб
   Nm = (Na < Nb)? Na: Nb;	// бο¿Ƥ⾯ʤο
   (*idx0) = new IndexPair [Nm];
   Nm = fix_corresp(Jab, Na, Nb, N, *idx0, idx);

   delete [] grp;
   delete [] idx;
   delete [] x;
   
   return Nm;
}

// ǥκȥѥ
int
make_index2(Mat &Jab, Mat &lambda,
	    int Na, int Nb, IndexPair idx[], double x[],
	    int *NNa, int *NNb)
{
   int	k, ni, nj;

   // Υå
   nj = 0;
   for (int i = 0; i < Na; i++)
   {
      for (int j = 0; j < Nb; j++)
      {
	 if (lambda[i][j] >= 0.0)
	    goto FIND1;
      }
      // j ˤбĤʤ(iбʤ)
      for (int j = 0; j < Nb; j++)
	 Jab[i][j] = MISMATCH;
      continue;
      // j ˤбʾ夢ä
     FIND1:;
      nj++;
   }

   // ԤΥå
   ni = 0;
   for (int j = 0; j < Nb; j++)
   {
      for (int i = 0; i < Na; i++)
      {
	 if (lambda[i][j] >= 0.0)
	    goto FIND2;
      }
      // j ԤˤбĤʤ(iбʤ)
      for (int i = 0; i < Na; i++)
	 Jab[i][j] = MISMATCH;
      continue;
      // i Ԥˤбʾ夢ä
     FIND2:;
      ni++;
   }

   // ǥι
   k = 0;
   for (int i = 0; i < Na; i++)
   {
      for (int j = 0; j < Nb; j++)
      {
	 if (Jab[i][j] >= 0.0)
	 {
	    idx[k].a = i;
	    idx[k].b = j;
	    x[k] = Jab[i][j];
	    k++;
	 }
      }
   }

   *NNa = ni;
   *NNb = nj;

   return k;
}

// Jab ƥå
void
recheck_table(Mat& Jab, Mat& lambda, int Na, int Nb)
{
   // 7*SmʲͭȤ롥
   for (int a = 0; a < Na; a++)
   {
      for (int b = 0; b < Nb; b++)
      {
	 if (lambda[a][b] < 0.0)
	    Jab[a][b] = MISMATCH;
      }
   }
}

// ưб׻
int
init_matching(Image& Ima, Image& Imb,
	      Mat& Jab, Point **pa, Point **pb,
	      int* Na, int* Nb,
	      Corresp** croot, int* N,
	      int Pmax, int t_size, double pc, int ImpHrsFlg)
{
   IntTemplate	*Ta;
   IndexPair	*idx;
   Corresp	*cp;
   
   // ƲħФ
   feature_extraction(Ima, Pmax, pa, Na, ImpHrsFlg);
   feature_extraction(Imb, Pmax, pb, Nb, ImpHrsFlg);

   // 1ħƥץ졼ȤȤƼФ
   set_feature_templates(Ima, *pa, Na, &Ta, t_size);

   // бɽ롥
   Jab.realloc(*Na, *Nb);
   make_table(Ta, *Na, Imb, *pb, *Nb, Jab);

   // бγ
   *N = make_corresp(Jab, *pa, *Na, *pb, *Nb, pc, &idx);

   // бФι¤ΤؤѴ
   cp = (*croot) = new Corresp [*N];
   corresp_pairs(*pa, *pb, idx, *N, cp);

   return *N;
}
