#ifndef	_LMEDS_H_
#define	_LMEDS_H_

#define	H_MIN_PTS	4

#define	SUCCEEDED	0
#define	FAILED		-1
#define	DEGEN_EPS	1e-10

#include	<ctime>
#include	<complex>

typedef	std::complex<double>	Complex;

#include	"Mat.h"
#include	"Corresp_cls.h"
#include	"init_match.h"
#include	"lmeds_consts.h"

//////////////////////////////////////////////////////////////////////
//
// μ(ᥤ˰Ĥ)
//

#ifdef LMEDS_MAIN
long		idum;
#else
extern long	idum;
#endif

//////////////////////////////////////////////////////////////////////
//
// ѴκǾ᥸ˡ
//

// Ǿ᥸ˡˤ¿ʤη׻
double	lmeds_tr(Corresp cp[], VecC Xa[], VecC Xb[], double J[],
		 int N, int MaxItr, VecC& Tm);

// Ǿ᥸ˡˤѴη׻
double	lmeds_sim(Corresp cp[], Complex za[], Complex zb[], double J[], int N,
		  int MaxItr, Complex& Zm0, double *ssm0,
		  Complex& zzm00, Complex& zzm01);

// Ǿ᥸ˡˤ륢եѴη׻
double	lmeds_aff(Corresp cp[], VecC Xa[], VecC Xb[], double J[], int N,
		  int MaxItr, Mat& Am0, Mat& Wm0);

// Ǿ᥸ˡˤͱѴη׻
double	lmeds_homo(Corresp cp[], VecC Xa[], VecC Xb[], double J[],
		   int N, double fl, int MaxItr, Mat& Hm);

//////////////////////////////////////////////////////////////////////
//
// ƤϤ
//

// ¿ʤκƤϤ
void	recalc_tr(Corresp cp[],
		  VecC Xa0[], VecC Xb0[], double J[],
		  int N, double Sm, VecC& Tm,
		  Corresp **ncp, int *Nn, VecC& T);

// ѴκƤϤ
void	recalc_sim(Corresp cp[], Complex za0[], Complex zb0[],
		   double J[], int N, double Sm, Complex& Zm,
		   double ssm, Complex& zzm0, Complex& zzm1,
		   Corresp **ncp, int *Nn, Mat& Rr, VecC& tr, double *ssr);

// եѴκƤϤ
void	recalc_aff(Corresp cp[], VecC Xa0[], VecC Xb0[], double J[], int N,
		   double Sm, Mat& Am, Mat& Wm,
		   Corresp **ncp, int *Nn, Mat& An, Mat& Wn);

// ͱѴκƤϤ
void	recalc_homo(Corresp cp[], VecC Xa0[], VecC Xb0[], double J[], int N,
		    double Sm, Mat& Hm,
		    Corresp **ncp, int *Nn, Mat& Hn);

#endif	//	_LMEDS_HOMO_H_

