//
// եѴκǾ᥸ˡ
//

#include	"Mat.h"

#include	"Corresp_cls.h"

#include	"affine.h"
#include	"lmeds.h"

// ʬμФ
static Mat
get_submatrix22(Mat& A)
{
   Mat	A2(2,2);

   A2[0][0] = A[0][0];
   A2[0][1] = A[0][1];
   A2[1][0] = A[1][0];
   A2[1][1] = A[1][1];

   return A2;
}

// ʬؤν񤭹
static Mat
put_submatrix22(Mat& A2)
{
   Mat	A;

   A[0][0] = A2[0][0];
   A[0][1] = A2[0][1];
   A[1][0] = A2[1][0];
   A[1][1] = A2[1][1];
   A[0][2] = A[1][2] = A[2][0] = A[2][1] = A[2][2] = 0.0;

   return A;
}

// W η׻
static Mat
calc_W(Mat& A)
{
   Mat	W;
   Mat	A2(2,2), W2(2,2), I2(2,2);

   A2 = get_submatrix22(A);

   I2 = id_matrix(2);
   W2 = inverse(I2 + A2 * (~A2));
   W = put_submatrix22(W2);

   return W;
}

// J_{\lambda}η׻
static double
calc_J_lambda_aff(Mat& A, Mat& W, VecC& Xa, VecC& Xb)
{
   VecC		T;
   double	J;

   T = Xb - A * Xa;
   J = (T, (W * T));

   return J;
}

// եѴη׻
static int
calc_aff_lsm(VecC Xa[], VecC Xb[],
	     int l0, int l1, int l2,
	     Mat& A)
{
   Mat	BB, AA;
   double	da, db;

   da = (Xa[l0], (Xa[l1] % Xa[l2]));
   db = (Xb[l0], (Xb[l1] % Xb[l2]));

   // ľ˺ܤäƤ뤫ಽȽ
   if ((fabs(da) < DEGEN_EPS) || (fabs(db) < DEGEN_EPS))
   {
      return FAILED;
   }

   for (int i = 0; i < 3; i++)
   {
      AA[i][0] = Xa[l0][i];
      AA[i][1] = Xa[l1][i];
      AA[i][2] = Xa[l2][i];
      BB[i][0] = Xb[l0][i];
      BB[i][1] = Xb[l1][i];
      BB[i][2] = Xb[l2][i];
   }

   A = BB * inverse(AA);

   return SUCCEEDED;
}

// ׻줿եѴ󤫤бФλĺ׻
static double
calc_aff_med(Mat& A, Mat& W, VecC Xa[], VecC Xb[], int N, double J0[])
{
   double	t;
   double	J[N];

   // Wη׻
   W = calc_W(A);
   // ĺη׻
   for (int i = 0; i < N; i++)
      J0[i] = J[i] = calc_J_lambda_aff(A, W, Xa[i], Xb[i]);

   // ˥
   for (int i = 0; i < N - 1; i++)
      for (int j = i + 1; j < N; j++)
      {
	 if (J[i] > J[j])
	 {
	    t = J[j]; J[j] = J[i]; J[i] = t;
	 }
      }

   return J[N/2];
}

// Ǿ᥸ˡˤ륢եѴη׻
double
lmeds_aff(Corresp cp[], VecC Xa[], VecC Xb[], double J[], int N,
	  int MaxItr, Mat& Am0, Mat& Wm0)
{
   double	S, Sm;
   Mat		A, Am;
   Mat		W, Wm;
   int		idx0, idx1, idx2;
   int		count, ct;


   // ֤Τν
   Sm = INF;
   Am = Wm = W = id_matrix(3);
   count = ct = 0;

   if (N > H_MIN_PTS * 4)
   {
      // бΥڥʬʸĿФǤ: 
      while (count < MaxItr)
      {
	 count++;

	 // 3
	 idx0 = (int)(N * ran1(&idum));
	 while ((idx1 = (int)(N * ran1(&idum))) == idx0);
	 while ((idx2 = (int)(N * ran1(&idum))) == idx0 || idx2 == idx1);

	 // եѴη׻
	 if (calc_aff_lsm(Xa, Xb, idx0, idx1, idx2, A))
	    continue;	// ಽ

	 // бФλĺͤη׻
	 S = calc_aff_med(A, W, Xa, Xb, N, J);

	 // 
	 if (S < Sm)
	 {
	    Sm = S;
	    Am = A;
	    Wm = W;
	    ct = 0;
	 }
	 else	// Ϣ³ COUNT_AFF(7) ʾǽλ
	 {	// ȥ饤Ψ: 2䡤ȽΨ 1%ʲ
	    if (++ct >= COUNT_AFF)
	       break;
	 }
      }
   }
   else
   {
      // бΥڥʤ: 
      // 3
      for (int idx0 = 0; idx0 < N - 2; idx0++)
      {
	 for (int idx1 = idx0 + 1; idx1 < N - 1; idx1++)
	 {
	    for (int idx2 = idx1 + 1; idx2 < N; idx2++)
	    {
	       // եѴη׻
	       if (calc_aff_lsm(Xa, Xb, idx0, idx1, idx2, A))
		  continue;	// ಽ

	       // бФλĺͤη׻
	       S = calc_aff_med(A, W, Xa, Xb, N, J);

	       // 
	       if (S < Sm)
	       {
		  Sm = S;
		  Am = A;
		  Wm = W;
	       }
	    }
	 }
      }
   }

   Am0 = Am;
   Wm0 = Wm;

   return Sm;
}

// եѴκƤϤ
void
recalc_aff(Corresp cp[], VecC Xa0[], VecC Xb0[], double J[], int N,
	   double Sm, Mat& Am, Mat& Wm,
	   Corresp **ncp, int *Nn, Mat& An, Mat& Wn)
{
   VecC		*Xa, *Xb;
   int		Nc, k;
   double	epsh;
   int		cnt;

   // Ʒ׻˻ȤбФο
   Nc = 0;
   for (int i = 0; i < N; i++)
   {
      J[i] = calc_J_lambda_aff(Am, Wm, Xa0[i], Xb0[i]);
      if (J[i] < THD * Sm)
	 Nc++;
   }

   Xa = new VecC [Nc];
   Xb = new VecC [Nc];
   *ncp = new Corresp [Nc];
   *Nn = Nc;

   k = 0;
   for (int i = 0; i < N; i++)
   {
      if (J[i] < THD * Sm)
      {
	 (*ncp)[k].ua = cp[i].ua;
	 (*ncp)[k].va = cp[i].va;
	 (*ncp)[k].ub = cp[i].ub;
	 (*ncp)[k].vb = cp[i].vb;
	 Xa[k] = Xa0[i];
	 Xb[k] = Xb0[i];
	 k++;
      }
   }

   // ˥塼ȥˡξ
//   calc_affine(Xa, Xb, (*Nn), An, 1e-8, 30, &epsh, &cnt);
//   cerr << "> An " << An << endl;

   // LMˡξ
   calc_affinelm(Xa, Xb, (*Nn), An, 1e-8, 30, &epsh, &cnt);
//   cerr << "< An " << An << endl;

   Wn = calc_W(An);
}
