//
// $B%/%i%9(B Vec, VecC, VecR $B$N3F<o1i;;!"B>(B
//

#include <iostream>
#include <cstdlib>
#include <cassert>

using namespace std;

#include "Vec.h"

// $B%5%$%:$NJQ99(B
void
Vec::renew(int n)
{
   double       *p, *r, *q = vec;
   int          ni;

   if (n == _n)  return;
   r = p = new double[n];
   if (r == NULL)
   {
      cerr << "### Memory Alloc Error (Vec.realoc) ###\n";
      abort();
   }

   ni = (n < _n)? n: _n;
   for (int i = 0; i < ni; i++)
      *p++ = *q++;
   if (_n < n)
      for (int i = _n; i < n; i++)
         *p++ = 0.0;

   delete [] vec;
   vec = r;
   _n = n;
}

// $B%5%$%:$NJQ99(B
void
VecR::realloc(int n)
{
   Vec::renew(n);
}

void
VecC::realloc(int n)
{
   Vec::renew(n);
}

// $B%Y%/%H%k$N@dBPCM(B
VecC
abs(const VecC& V)
{
   VecC	        T(V._n);
   double       *p = T.vec, *q = V.vec;

   for (int i = 0; i < T._n; i++)
      *p++ = fabs(*q++);

   return T;
}

VecR
abs(const VecR& V)
{
   VecR	        T(V._n);
   double       *p = T.vec, *q = V.vec;

   for (int i = 0; i < T.size(); i++)
      *p++ = fabs(*q++);

   return T;
}

static void
delete_parenthese(char *buff, int len)
{
   for (int i = 0; buff[i] != '\0' && i < len; i++)
   {
      if (buff[i] == '(' || buff[i] == ')' || buff[i] == 't')
	 buff[i] = ' ';
   }
}

static char*
next_token(char **p)
{
   int	i;
   char	*q;

   i = 0;
   q = *p;
   while (q[i] == ' ' || q[i] == '\t')
      i++;
   q += i;
   i = 0;
   while (q[i] != ' ' && q[i] != '\t' && q[i] != '\0')
      i++;

   q[i] = '\0';
   *p = q + i + 1;

   return q;
}

// $B%9%H%j!<%`$+$i$N3FMWAG$NF~NO(B
istream&
operator >> (istream& s, Vec& V)
{
   char		buff[256], *bp, *bq;
   double       *p = V.vec;

   s.getline(buff, sizeof(buff));
   delete_parenthese(buff, sizeof(buff));
   bp = bq = buff;
   for (int i = 0; i < V._n; i++)
   {
      bp = next_token(&bq);
      *p++ = atof(bp);
   }
   return s;
}

// $B%9%H%j!<%`$X$N%Y%/%H%k$N=PNO(B
ostream&
operator << (ostream& s, const VecR& V)
{
   double       *p = V.vec;

   s << "( ";
   for (int i = 0; i < V._n; i++, p++)
      s << ((fabs(*p) <= EPS)? 0: *p) << " ";
   s << ")";
   return s;
}

ostream&
operator << (ostream& s, const VecC& V)
{
   double       *p = V.vec;

   s << "( ";
   for (int i = 0; i < V._n; i++, p++)
      s << ((fabs(*p) <= EPS)? 0: *p) << " ";
   s << ")t";
   return s;
}

// $B%9%+%i!<$G$N=|;;(B
VecR
operator / (const VecR& V, double a)
{
   VecR         T(V);
   double       *p = T.vec;

   for (int i = 0; i < T._n; i++)
      *p++ /= a;
   return T;
}

VecC	operator / (const VecC& V, double a)
{
   VecC         T(V._n);
   double       *p = T.vec, *q = V.vec;

   for (int i = 0; i < T._n; i++)
      *p++ = *q++ / a;
   return T;
}

// $B%9%+%i!<G\(B
VecR	operator * (const VecR& V, double a)
{
   VecR         T(V);
   double       *p = T.vec;

   for (int i = 0; i < T._n; i++)
      *p++ *= a;
   return T;
}

VecC
operator * (const VecC& V, double a)
{
   VecC	        T(V._n);
   double       *p = T.vec, *q = V.vec;

   for (int i = 0; i < T._n; i++)
      *p++ = *q++ * a;
   return T;
}

// $BFb@Q(B
double
operator , (const VecR& V1, const VecR& V2)
{
   double	x = 0;
   double       *p = V1.vec, *q = V2.vec;

   assert(V1._n == V2._n);
   for (int i = 0; i < V1._n; i++)
      x += (*p++) * (*q++);
   return x;
}

double
operator , (const VecC& V1, const VecC& V2)
{
   double	x = 0;
   double       *p = V1.vec, *q = V2.vec;

   assert(V1._n == V2._n);
   for (int i = 0; i < V1._n; i++)
      x += (*p++) * (*q++);
   return x;
}

// $BC19`$N(B - $B1i;;;R(B
VecR
operator - (const VecR& V)
{
   VecR	        T(V._n);
   double       *p = T.vec, *q = V.vec;

   for (int i = 0; i < V._n; i++)
      *p++ = -(*q++);
   return T;
}

VecC
operator - (const VecC& V)
{
   VecC	        T(V._n);
   double       *p = T.vec, *q = V.vec;

   for (int i = 0; i < V._n; i++)
      *p++ = -(*q++);
   return T;
}

// $B%Y%/%H%k$N@55,2=(B
VecR
normalize(const VecR& V)
{
   VecR		T(V);
   double	d;

   if ((d = V.norm()) < EPS)
   {
      T.clear();
      return T;
   }
   else
      return V / d;
}

VecC
normalize(const VecC& V)
{
   VecC		T(V);
   double	d;

   if ((d = V.norm()) < EPS)
   {
      T.clear(0.0);
      return T;
   }
   return T / d;
}

// $B%Y%/%H%k$NHf3S!'0lCW(B
//	$B7W;;8m:9(B($B7eMn$A!"4]$aEy(B)$B$r9MN8(B
int
operator == (const Vec& V1, const Vec& V2)
{
   double       *p = V1.vec, *q = V2.vec;

   assert(V1._n == V2._n);
   for (int i = 0; i < V1._n; i++)
      if (fabs(*p++ - *q++) > EPS)  return False;

   return True;
}

// $B%Y%/%H%k$NHf3S!'IT0lCW(B
//	$B7W;;8m:9(B($B7eMn$A!"4]$aEy(B)$B$r9MN8(B
int
operator != (const Vec& V1, const Vec& V2)
{
   double       *p = V1.vec, *q = V2.vec;
   assert(V1._n == V2._n);
   for (int i = 0; i < V1._n; i++)
      if (fabs(*p++ - *q++) > EPS)  return True;

   return False;
}

// $B%Y%/%H%k$N30@Q(B (3x3$B$N$_(B)
VecR
operator % (const VecR& V1, const VecR& V2)
{
   double	x[3];

   assert(V1._n == 3 && V2._n == 3);
   x[0] = V1.vec[1] * V2.vec[2] - V1.vec[2] * V2.vec[1];
   x[1] = V1.vec[2] * V2.vec[0] - V1.vec[0] * V2.vec[2];
   x[2] = V1.vec[0] * V2.vec[1] - V1.vec[1] * V2.vec[0];
   return VecR(x, 3);
}

VecC
operator % (const VecC& V1, const VecC& V2)
{
   double	x[3];

   assert(V1._n == 3 && V2._n == 3);
   x[0] = V1.vec[1] * V2.vec[2] - V1.vec[2] * V2.vec[1];
   x[1] = V1.vec[2] * V2.vec[0] - V1.vec[0] * V2.vec[2];
   x[2] = V1.vec[0] * V2.vec[1] - V1.vec[1] * V2.vec[0];
   return VecC(x, 3);
}
