#include "nradd.h"

#define ITMAX 100
#define _EPS 3.0e-7
#define FPMIN 1.0e-30

/*
 * sSK}֐ Q(a,x) Aŋ߁Cgammcf ɓĖ߂D
 * ܂ ln (a)  gln ɓD
 */
void
gcf(double *gammcf, double a, double x, double *gln)
{
   int i;
   double an,b,c,d,del,h;

   *gln=gammln(a);
   b=x+1.0-a;
   c=1.0/FPMIN;
   d=1.0/b;
   h=d;
   for (i=1;i<=ITMAX;i++) {
      an = -i*(i-a);
      b += 2.0;
      d=an*d+b;
      if (fabs(d) < FPMIN) d=FPMIN;
      c=b+an/c;
      if (fabs(c) < FPMIN) c=FPMIN;
      d=1.0/d;
      del=d*c;
      h *= del;
      if (fabs(del-1.0) < _EPS) break;
   }
   if (i > ITMAX) nrerror("a too large, ITMAX too small in gcf");
   *gammcf=exp(-x+a*log(x)-(*gln))*h;
}

/*
 * sSK}֐ P(a,x) ŋ߁Cgamser ɓĖ߂D
 * ܂Cln (a)  gln ɓD
 */
void
gser(double *gamser, double a, double x, double *gln)
{
   int n;
   double sum,del,ap;

   *gln=gammln(a);
   if (x <= 0.0) {
      if (x < 0.0) nrerror("x less than 0 in routine gser");
      *gamser=0.0;
      return;
   } else {
      ap=a;
      del=sum=1.0/a;
      for (n=1;n<=ITMAX;n++) {
	 ++ap;
	 del *= x/ap;
	 sum += del;
	 if (fabs(del) < fabs(sum)*_EPS) {
	    *gamser=sum*exp(-x+a*log(x)-(*gln));
	    return;
	 }
      }
      nrerror("a too large, ITMAX too small in routine gser");
      return;
   }
}

/*
 * sSK}֐ P(a,x) ԂD
 */
double
gammp(double a, double x)
{
   double gamser,gammcf,gln;

   if (x < 0.0 || a <= 0.0) nrerror("Invalid arguments in routine gammp");
   if (x < (a+1.0)) {
      gser(&gamser,a,x,&gln);
      return gamser;
   } else {
      gcf(&gammcf,a,x,&gln);
      return 1.0-gammcf;
   }
}

/*
 * sSK}֐ Q(a,x) ԂD
 */
double
gammq(double a, double x)
{
   double gamser,gammcf,gln;

   if (x < 0.0 || a <= 0.0) nrerror("Invalid arguments in routine gammq");
   if (x < (a+1.0)) {
      gser(&gamser,a,x,&gln);
      return 1.0-gamser;
   } else {
      gcf(&gammcf,a,x,&gln);
      return gammcf;
   }
}

/*
 * Rx˂̃JCm֐ P(^2,)
 */
double
chipdist(double chi2, int nu)
{
   return gammp(nu/2.0, chi2/2.0);
}

double
chipdistr(double chi2, double nu)
{
   return gammp(nu/2.0, chi2/2.0);
}

/*
 * Rx˂̃JCm֐ Q(2,) = 1.0 - P(^2,)
 */
double
chiqdist(double chi2, int nu)
{
   return gammq(nu/2.0, chi2/2.0);
}

double
chiqdistr(double chi2, double nu)
{
   return gammq(nu/2.0, chi2/2.0);
}

/*
 * JC㑤p[Zg_ Qinv(p,)
 */
double
chiqinv(double p0, int nu)
{
   double	xl, xr, xm;
   double	p;

   xl = 0.0;
   xr = 1e8;

   do
   {
      xm = (xl + xr) / 2.0;
      p = chiqdist(xm, nu);
      if (p > p0)
	 xl = xm;
      else
	 xr = xm;
   }
   while (fabs(xr - xl)/xm > _EPS);
   
   return xm;
}

double
chiqinvr(double p0, double nu)
{
   double	xl, xr, xm;
   double	p;

   xl = 0.0;
   xr = 1e8;

   do
   {
      xm = (xl + xr) / 2.0;
      p = chiqdistr(xm, nu);
      if (p > p0)
	 xl = xm;
      else
	 xr = xm;
   }
   while (fabs(xr - xl)/xm > _EPS);
   
   return xm;
}

#undef FPMIN
#undef _EPS
#undef ITMAX
