//
// ʳŪޥå󥰤ˤͱѴ׻
//
//	ᥤ
//

#include        <iostream>
#include        <fstream>
#include        <cstdio>

using namespace std;

#include        <unistd.h>

#define	MAIN

#include	"CImage.h"
#include	"Mat.h"

#include	"Corresp_cls.h"
#include	"init_match.h"
#include	"automatch.h"
#include	"matcher_consts.h"

// form ؿ
#define TMPBUFLEN       80
static char tmpbuff[TMPBUFLEN];

double	EPS = 1e-10;
double	DET_EPS = 1e-10;

void
usage(char *command)
{
   cerr << "usage: " << command
	<< " [-f fl] [-N Np] [-t tpsize]"
	<< " [-d dthd] [-I pc] [-i pcstep] "
	<< " [-1 image1-point -2 image2-point]"
	<< " [-M matrix-file] [-m match-file] "
	<< " [-v] [-n] [-h] image1-ppm image2-ppm" << endl;
   cerr << "  Input file:  image1-ppm, image2-ppm" << endl;
   cerr << "  Output file: image1-point, image2-point, matrix-file, match-file" << endl;
   cerr << "  Options:" << endl;
   cerr << "     -f fl\t\tScale factor for stability of computing (600)" << endl;
   cerr << "     -N Np\t\tMaximum Number for feature points detection (100)" << endl;
   cerr << "     -I pc\t\tInitial ratio of correct matches (0.6)" << endl;
   cerr << "     -i pcstep\t\tIncremental value of 'pc' (0.1)" << endl;
   cerr << "     -t tpsize\t\tInitial template size (9x9)" << endl;
   cerr << "     -d dthd\t\tDistance threshold of inliers (3)" << endl;
   cerr << "  Miscellaneous options:" << endl;
   cerr << "     -n\t\t\tdoing normalized correlation" << endl;
   cerr << "     -H\t\t\tusing standard Harris instead of improved Harris" << endl;
   cerr << "\t\t\tfor feature point detection" << endl;
   cerr << "     -h\t\t\thelp" << endl;
   cerr << "     -v\t\t\tverbose" << endl;
}

void
output_matches(char *filename, Corresp *cp, int N)
{
   if (*filename == '\0')
   {
      cout << "Final matches = " << N << endl;
      for (int i = 0; i < N; i++)
      {
         snprintf(tmpbuff, TMPBUFLEN, "(%4d,%4d)--(%4d,%4d)",
                  cp[i].ua, cp[i].va, cp[i].ub, cp[i].vb);
	 cout << tmpbuff << endl;
      }
   }
   else
   {
      ofstream	fout(filename);

      if (fout.bad())
      {
	 cerr << "output_matches(): unable to open " << filename << endl;
	 return;
      }
      for (int i = 0; i < N; i++)
      {
         snprintf(tmpbuff, TMPBUFLEN, "(%4d,%4d)--(%4d,%4d)",
                  cp[i].ua, cp[i].va, cp[i].ub, cp[i].vb);
	 fout << tmpbuff << endl;
      }
      fout.close();
   }
}

void
output_features(char *filename, Point *pt, int N)
{
   ofstream	fout(filename);

   if (fout.bad())
   {
      cerr << "output_features(): unable to open " << filename << endl;
      return;
   }

   for (int i = 0; i < N; i++)
   {
      snprintf(tmpbuff, TMPBUFLEN, "(%4d,%4d)", pt[i].u, pt[i].v);
      fout << tmpbuff << endl;
   }

   fout.close();
}
   
void
output_mat(char *filename, Mat& A)
{
   ofstream	fout(filename);

   if (fout.bad())
   {
      cerr << "output_mat(): unable to open " << filename << endl;
      return;
   }

   snprintf(tmpbuff, TMPBUFLEN, "(%20.15f %20.15f %20.15f )",
            A[0][0], A[0][1], A[0][2]);
   fout << tmpbuff << endl;
   snprintf(tmpbuff, TMPBUFLEN, "(%20.15f %20.15f %20.15f )",
            A[1][0], A[1][1], A[1][2]);
   fout << tmpbuff << endl;
   snprintf(tmpbuff, TMPBUFLEN, "(%20.15f %20.15f %20.15f )",
            A[2][0], A[2][1], A[2][2]);
   fout << tmpbuff << endl;
}
   

int
main(int argc, char **argv)
{
   CImage	Im1, Im2;
   Corresp	*cp;
   Point        *pa, *pb;
   int		N, Na, Nb;
   char		im1_name[80], im2_name[80], match_name[80];
   char		M_name[80], im1pt_name[80], im2pt_name[80];
   int		Np, tp_size;
   int		verbose;
   int          ImpHrsFlg;
   double	dthd, fl;
   double	pc, pc_step;
   Mat		H;
   int		opt;

   // ǥե
   fl = DEFAULT_FL;
   Np = DEFAULT_NP;
   tp_size = DEFAULT_TPSIZE;
   dthd = DEFAULT_DTHD;
   verbose = VERBOSE;
   pc = DEFAULT_PC;
   pc_step = DEFAULT_PC_STEP;
   ImpHrsFlg = DEFAULT_IMP_HARRIS;
   im1pt_name[0] = im2pt_name[0] = M_name[0] = match_name[0] = '\0';

   while ((opt = getopt(argc, argv, "1:2:M:f:N:I:i:t:d:m:vhH")) != -1)
   {
      switch (opt)
      {
	case '1':
	   strcpy(im1pt_name, optarg);
	   break;
	case '2':
	   strcpy(im2pt_name, optarg);
	   break;
	case 'M':
	   strcpy(M_name, optarg);
	   break;
	case 'f':
	   fl = atof(optarg);
	   break;
	case 'N':	// Фħ
	   Np = atoi(optarg);
	   break;
	case 'I':
	   pc = atof(optarg);
	   break;
	case 'i':
	   pc_step = atof(optarg);
	   break;
	case 't':
	   tp_size = atoi(optarg);
	   if (!(tp_size % 2))
	      cerr << "Warning: we use " << (tp_size * 2 + 1)
		   << " as template size!" << endl;
	   tp_size /= 2;
	   break;
	case 'd':
	   dthd = atof(optarg);
	   break;
	case 'm':
	   strcpy(match_name, optarg);
	   break;
	case 'h':
	   usage(argv[0]);
	   exit(1);
	   break;
	case 'v':
	   verbose = 1;
	   break;
	case 'H':
	   ImpHrsFlg = 0;
	   break;
	default:
	   usage(argv[0]);
	   exit(1);
	   break;
      }
   }

   if (optind < argc)
   {
      strcpy(im1_name, argv[optind++]);
      strcpy(im2_name, argv[optind++]);
   }
   else
   {
      usage(argv[0]);
      exit(1);
   }

   if (verbose)
   {
      cerr << "[Inputs]" << endl;
      cerr << "  First Image: " << im1_name << endl;
      cerr << "  Second Image: " << im2_name << endl;
      cerr << "  Focal length: " << fl << endl;
      cerr << "  Maximum number of detected feature points: " << Np << endl;
      cerr << "  Template size: " << tp_size * 2 + 1
	   << " x " << tp_size * 2 + 1  << endl;
      cerr << "  Threshold of distance: " << dthd << endl;
      cerr << "  percentage of correct matches: " << pc << endl;
      cerr << "  step of percentage of correct matches: " << pc_step << endl;

      cerr << "[Outputs]" << endl;
      cerr << "  Matches => " << match_name << endl;
      cerr << "  Homography matrix => " << M_name << endl;
      cerr << "  Feature points in the first image => " << im1pt_name << endl;
      cerr << "  Feature points in the second image => " << im2pt_name << endl;
      cerr << endl;
   }

   // եɤ߹
   if (load_ppm_file(Im1, im1_name))
   {
      cerr << "Error: cannot open " << im1_name << endl;
      exit(1);
   }
   if (load_ppm_file(Im2, im2_name))
   {
      cerr << "Error: cannot open " << im2_name << endl;
      exit(1);
   }

   automatch_homography(Im1, Im2, fl, Np, tp_size,
			pc, pc_step, dthd, ImpHrsFlg,
			&cp, &N, &pa, &Na, &pb, &Nb, H, verbose);

   output_matches(match_name, cp, N);

   if (im1pt_name[0] != '\0')
      output_features(im1pt_name, pa, Na);

   if (im2pt_name[0] != '\0')
      output_features(im2pt_name, pb, Nb);

   if (M_name[0] != '\0')
      output_mat(M_name, H);

   cout << endl;
   snprintf(tmpbuff, TMPBUFLEN, "(%20.15f %20.15f %20.15f )",
            H[0][0], H[0][1], H[0][2]);
   cout << tmpbuff << endl;
   snprintf(tmpbuff, TMPBUFLEN, "(%20.15f %20.15f %20.15f )",
            H[1][0], H[1][1], H[1][2]);
   cout << tmpbuff << endl;
   snprintf(tmpbuff, TMPBUFLEN, "(%20.15f %20.15f %20.15f )",
            H[2][0], H[2][1], H[2][2]);
   cout << tmpbuff << endl;
}
