//
// Ϳ줿ͱѴѤơѴ롥
// Υ⥶κ
//
#include <iostream>
#include <fstream>

using namespace std;

#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>

#define MAIN

#include        "Mat.h"
#include        "CImage.h"

double  EPS = 1e-10;
double	DET_EPS = 1e-10;

// ͱѴɤ߹
int
read_H(char *filename, Mat& H)
{
   ifstream     data_file(filename);

   if (data_file.bad())
   {
      cerr << "Unable to open " << filename << endl;
      return 0;
   }

   data_file >> H;

   data_file.close();

   return 1;
}

// 礵줿4κɸ
//      A: B: C: D: 
//      濴Ȥ4
int
read_rectangle(char *filename, VecC& A, VecC& B, VecC& C, VecC& D)
{
   ifstream     data_file(filename);

   if (data_file.bad())
   {
      cerr << "Unable to open " << filename << endl;
      return 0;
   }

   data_file >> A >> B >> C >> D;

   data_file.close();

   return 1;
}

// Ǿ
double
min(double x1, double x2, double x3, double x4)
{
   double       minx = 1e99;

   if (x1 < minx)  minx = x1;
   if (x2 < minx)  minx = x2;
   if (x3 < minx)  minx = x3;
   if (x4 < minx)  minx = x4;

   return minx;
}

// 
double
max(double x1, double x2, double x3, double x4)
{
   double       maxx = -1e99;

   if (x1 > maxx)  maxx = x1;
   if (x2 > maxx)  maxx = x2;
   if (x3 > maxx)  maxx = x3;
   if (x4 > maxx)  maxx = x4;

   return maxx;
}

// 4μͱѴκɸ롥
void
calc_frame(int width, int height, double fl,
           const Mat& H, VecC& A, VecC& B, VecC& C, VecC& D)
{
   VecC         A0( height/2, -width/2, fl);
   VecC         B0( height/2,  width/2, fl);
   VecC         C0(-height/2,  width/2, fl);
   VecC         D0(-height/2, -width/2, fl);

   A0 = Znorm(A0);
   B0 = Znorm(B0);
   C0 = Znorm(C0);
   D0 = Znorm(D0);
   A = Znorm(H * A0) * fl;
   B = Znorm(H * B0) * fl;
   C = Znorm(H * C0) * fl;
   D = Znorm(H * D0) * fl;
}

// 4ѷΰäƤ뤫ɤ
int
rect_in(VecC& A, VecC& B, VecC& C, VecC& D, int x, int y, double fl)
{
   VecC P((double)x, (double)y, fl);
   VecC X, Y, Z;
   int  flag1, flag2, flag3, flag4;

   flag1 = flag2 = flag3 = flag4 = 0;

   X = A - P; Y = B - P; Z = X % Y;
   if (Z[2] > 0) flag1 = 1;

   X = Y; Y = C - P; Z = X % Y;
   if (Z[2] > 0) flag2 = 1;

   X = Y; Y = D - P; Z = X % Y;
   if (Z[2] > 0) flag3 = 1;

   X = Y; Y = A - P; Z = X % Y;
   if (Z[2] > 0) flag4 = 1;

   if (flag1 != flag2) return 0;
   if (flag2 != flag3) return 0;
   if (flag3 != flag4) return 0;
   if (flag4 != flag1) return 0;

   return 1;
}

// 
int
interpolation_r(CImage& ORG, double xp, double yp,
		int x0, int y0, int x1, int y1)
{
   double       p11, p21, p12, p22;
   double       f1x, f2x, f1y, f2y;
   int          p;

   p11 = ORG.get_pixel_r(x0, y0);
   p21 = ORG.get_pixel_r(x1, y0);
   p12 = ORG.get_pixel_r(x0, y1);
   p22 = ORG.get_pixel_r(x1, y1);

   f2x = xp - x0;
   f1x = 1.0 - f2x;
   f2y = yp - y0;
   f1y = 1.0 - f2y;

   p = (int)rint(  f1y * (p11 * f1x + p21 * f2x)
                 + f2y * (p12 * f1x + p22 * f2x));
   return p;
}

int
interpolation_g(CImage& ORG, double xp, double yp,
		int x0, int y0, int x1, int y1)
{
   double       p11, p21, p12, p22;
   double       f1x, f2x, f1y, f2y;
   int          p;

   p11 = ORG.get_pixel_g(x0, y0);
   p21 = ORG.get_pixel_g(x1, y0);
   p12 = ORG.get_pixel_g(x0, y1);
   p22 = ORG.get_pixel_g(x1, y1);

   f2x = xp - x0;
   f1x = 1.0 - f2x;
   f2y = yp - y0;
   f1y = 1.0 - f2y;

   p = (int)rint(  f1y * (p11 * f1x + p21 * f2x)
                 + f2y * (p12 * f1x + p22 * f2x));
   return p;
}

int
interpolation_b(CImage& ORG, double xp, double yp,
		int x0, int y0, int x1, int y1)
{
   double       p11, p21, p12, p22;
   double       f1x, f2x, f1y, f2y;
   int          p;

   p11 = ORG.get_pixel_b(x0, y0);
   p21 = ORG.get_pixel_b(x1, y0);
   p12 = ORG.get_pixel_b(x0, y1);
   p22 = ORG.get_pixel_b(x1, y1);

   f2x = xp - x0;
   f1x = 1.0 - f2x;
   f2y = yp - y0;
   f1y = 1.0 - f2y;

   p = (int)rint(  f1y * (p11 * f1x + p21 * f2x)
                 + f2y * (p12 * f1x + p22 * f2x));
   return p;
}

void
usage(char *command)
{
   cerr << "usage: " << command
	<< " [-f fl] [-s maxscale] H-file image1-ppm image2-ppm output-ppm"
	<< endl;
}

int
main(int argc, char *argv[])
{
   CImage	ORIG;
   int          ac;
   VecC         A, B, C, D;
   VecC         P, R;
   Mat          H, H1;
   double       fl;
   double       maxS;
   int          Xmin, Xmax, Ymin, Ymax;
   int          Xmin_n, Xmax_n, Ymin_n, Ymax_n;
   char         orig_im_name[80], base_im_name[80], dest_im_name[80];
   char         H_name[80];
   int          width, height, nwidth, nheight, nw, nh;
   int          x, y, pr, pg, pb, qr, qg, qb, nr, ng, nb;
   double       xp, yp;
   int          x0, y0, x1, y1;
   int		opt;

   fl = 600;
   maxS = 5;

   while ((opt = getopt(argc, argv, "f:s:")) != -1)
   {
      switch (opt)
      {
	case 'f':
	   fl = atof(optarg);
	   break;
	case 's':
	   maxS = atof(optarg);
	   break;
	default:
	   usage(argv[0]);
	   exit(1);
	   break;
      }
   }

   if (optind < argc)
   {
      strcpy(H_name, argv[optind++]);
      strcpy(orig_im_name, argv[optind++]);
      strcpy(base_im_name, argv[optind++]);
      strcpy(dest_im_name, argv[optind]);
   }
   else
   {
      usage(argv[0]);
      exit(1);
   }

   read_H(H_name, H);
   H1 = inverse(H);

   CImage_set_quiet();

   load_ppm_file(ORIG, orig_im_name);

   width = ORIG.width();
   height = ORIG.height();
   calc_frame(width, height, fl, H, A, B, C, D);

   Xmin = (int)floor(min(A[0], B[0], C[0], D[0]));
   Xmax = (int)ceil(max(A[0], B[0], C[0], D[0]));
   Ymin = (int)floor(min(A[1], B[1], C[1], D[1]));
   Ymax = (int)ceil(max(A[1], B[1], C[1], D[1]));

   Xmin_n = (Xmin < - height / 2)? Xmin: - height / 2;
   Xmax_n = (Xmax >   height / 2)? Xmax:   height / 2;
   Ymin_n = (Ymin < - width / 2)? Ymin: - width / 2;
   Ymax_n = (Ymax >   width / 2)? Ymax:   width / 2;

   nw = abs(Ymax_n - Ymin_n);
   nh = abs(Xmax_n - Xmin_n);

   nwidth = (nw < maxS * width)?  nw: (int)(maxS * width);
   nheight = (nh < maxS * height)?  nh: (int)(maxS * height);

   CImage        DEST(nwidth, nheight);

   if (nw != nwidth)
   {
      Ymin_n = - (int)(maxS * width / 2.0);
      Ymax_n =   (int)(maxS * width / 2.0);
   }
   if (nh != nheight)
   {
      Xmin_n = - (int)(maxS * height / 2.0);
      Xmax_n =   (int)(maxS * height / 2.0);
   }

   DEST.set_center(-Ymin_n, Xmax_n);
   DEST.clear(0);
   impose_ppm_file(DEST, base_im_name);

   for (x = Xmin_n; x < Xmax_n; x++)
      for (y = Ymin_n; y < Ymax_n; y++)
      {
         P[0] = x;
         P[1] = y;
         P[2] = fl;
         R = Znorm(H1 * Znorm(P));
         xp = R[0] * fl;
         yp = R[1] * fl;
         x0 = (int)floor(xp);
         y0 = (int)floor(yp);
         x1 = (int)ceil(xp);
         y1 = (int)ceil(yp);

         pr = interpolation_r(ORIG, xp, yp, x0, y0, x1, y1);
         pg = interpolation_g(ORIG, xp, yp, x0, y0, x1, y1);
         pb = interpolation_b(ORIG, xp, yp, x0, y0, x1, y1);
         if (pr > 0 || pg > 0 || pb > 0)
         {
            qr = DEST.get_pixel_r(x, y);
            qg = DEST.get_pixel_g(x, y);
            qb = DEST.get_pixel_b(x, y);
            if (qr || qg || qb)
	    {
	       nr = abs(pr - qr);
	       ng = abs(pg - qg);
	       nb = abs(pb - qb);
	       nr = (nr <= 255)? nr: 255;
	       ng = (ng <= 255)? ng: 255;
	       nb = (nb <= 255)? nb: 255;
	       DEST.put_pixel_r(x, y, nr);
	       DEST.put_pixel_g(x, y, ng);
	       DEST.put_pixel_b(x, y, nb);
	    }
            else
	    {
                DEST.put_pixel_r(x, y, pr);
                DEST.put_pixel_g(x, y, pg);
                DEST.put_pixel_b(x, y, pb);
	    }
         }
      }

   save_ppm_file(DEST, dest_im_name);
}
